diff -crN ../src.orig/bin/initdb/initdb.sh ./bin/initdb/initdb.sh
*** ../src.orig/bin/initdb/initdb.sh	Sat Jun  2 11:17:50 2001
--- ./bin/initdb/initdb.sh	Sat Jun  2 11:32:47 2001
***************
*** 612,617 ****
--- 612,781 ----
              AND I.oid = X.indexrelid;" \
          | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
  
+ echo "CREATE VIEW pg_stat_all_tables AS \
+ 		SELECT \
+ 			C.oid AS relid, \
+ 			C.relname AS relname, \
+ 			pg_stat_get_numscans(C.oid) AS seq_scan, \
+ 			pg_stat_get_tuples_returned(C.oid) AS seq_tup_read, \
+ 			sum(pg_stat_get_numscans(I.indexrelid)) AS idx_scan, \
+ 			sum(pg_stat_get_tuples_fetched(I.indexrelid)) AS idx_tup_fetch, \
+ 			pg_stat_get_tuples_inserted(C.oid) AS n_tup_ins, \
+ 			pg_stat_get_tuples_updated(C.oid) AS n_tup_upd, \
+ 			pg_stat_get_tuples_deleted(C.oid) AS n_tup_del \
+ 		FROM pg_class C FULL OUTER JOIN \
+ 		     pg_index I ON C.oid = I.indrelid \
+ 		WHERE C.relkind = 'r' \
+ 		GROUP BY C.oid, C.relname;" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_stat_sys_tables AS \
+ 		SELECT * FROM pg_stat_all_tables \
+ 		WHERE relname ~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_stat_user_tables AS \
+ 		SELECT * FROM pg_stat_all_tables \
+ 		WHERE relname !~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_all_tables AS \
+ 		SELECT \
+ 			C.oid AS relid, \
+ 			C.relname AS relname, \
+ 			pg_stat_get_blocks_fetched(C.oid) - \
+ 				pg_stat_get_blocks_hit(C.oid) AS heap_blks_read, \
+ 			pg_stat_get_blocks_hit(C.oid) AS heap_blks_hit, \
+ 			sum(pg_stat_get_blocks_fetched(I.indexrelid) - \
+ 				pg_stat_get_blocks_hit(I.indexrelid)) AS idx_blks_read, \
+ 			sum(pg_stat_get_blocks_hit(I.indexrelid)) AS idx_blks_hit, \
+ 			pg_stat_get_blocks_fetched(T.oid) - \
+ 				pg_stat_get_blocks_hit(T.oid) AS toast_blks_read, \
+ 			pg_stat_get_blocks_hit(T.oid) AS toast_blks_hit, \
+ 			pg_stat_get_blocks_fetched(X.oid) - \
+ 				pg_stat_get_blocks_hit(X.oid) AS tidx_blks_read, \
+ 			pg_stat_get_blocks_hit(X.oid) AS tidx_blks_hit \
+ 		FROM pg_class C FULL OUTER JOIN \
+ 			pg_index I ON C.oid = I.indrelid FULL OUTER JOIN \
+ 			pg_class T ON C.reltoastrelid = T.oid FULL OUTER JOIN \
+ 			pg_class X ON C.reltoastidxid = X.oid \
+ 		WHERE C.relkind = 'r' \
+ 		GROUP BY C.oid, C.relname, T.oid, X.oid;" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_sys_tables AS \
+ 		SELECT * FROM pg_statio_all_tables \
+ 		WHERE relname ~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_user_tables AS \
+ 		SELECT * FROM pg_statio_all_tables \
+ 		WHERE relname !~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_stat_all_indexes AS \
+ 		SELECT \
+ 			C.oid AS relid, \
+ 			I.oid AS indexrelid, \
+ 			C.relname AS relname, \
+ 			I.relname AS indexrelname, \
+ 			pg_stat_get_numscans(I.oid) AS idx_scan, \
+ 			pg_stat_get_tuples_returned(I.oid) AS idx_tup_read, \
+ 			pg_stat_get_tuples_fetched(I.oid) AS idx_tup_fetch \
+ 		FROM pg_class C, \
+ 			pg_class I, \
+ 			pg_index X \
+ 		WHERE C.relkind = 'r' AND \
+ 			X.indrelid = C.oid AND \
+ 			X.indexrelid = I.oid;" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_stat_sys_indexes AS \
+ 		SELECT * FROM pg_stat_all_indexes \
+ 		WHERE relname ~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_stat_user_indexes AS \
+ 		SELECT * FROM pg_stat_all_indexes \
+ 		WHERE relname !~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_all_indexes AS \
+ 		SELECT \
+ 			C.oid AS relid, \
+ 			I.oid AS indexrelid, \
+ 			C.relname AS relname, \
+ 			I.relname AS indexrelname, \
+ 			pg_stat_get_blocks_fetched(I.oid) - \
+ 				pg_stat_get_blocks_hit(I.oid) AS idx_blks_read, \
+ 			pg_stat_get_blocks_hit(I.oid) AS idx_blks_hit \
+ 		FROM pg_class C, \
+ 			pg_class I, \
+ 			pg_index X \
+ 		WHERE C.relkind = 'r' AND \
+ 			X.indrelid = C.oid AND \
+ 			X.indexrelid = I.oid;" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_sys_indexes AS \
+ 		SELECT * FROM pg_statio_all_indexes \
+ 		WHERE relname ~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_user_indexes AS \
+ 		SELECT * FROM pg_statio_all_indexes \
+ 		WHERE relname !~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_all_sequences AS \
+ 		SELECT \
+ 			C.oid AS relid, \
+ 			C.relname AS relname, \
+ 			pg_stat_get_blocks_fetched(C.oid) - \
+ 				pg_stat_get_blocks_hit(C.oid) AS blks_read, \
+ 			pg_stat_get_blocks_hit(C.oid) AS blks_hit \
+ 		FROM pg_class C \
+ 		WHERE C.relkind = 'S';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_sys_sequences AS \
+ 		SELECT * FROM pg_statio_all_sequences \
+ 		WHERE relname ~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_statio_user_sequences AS \
+ 		SELECT * FROM pg_statio_all_sequences \
+ 		WHERE relname !~ '^pg_';" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_stat_activity AS \
+ 		SELECT \
+ 			D.oid AS datid, \
+ 			D.datname AS datname, \
+ 			pg_stat_get_backend_pid(S.backendid) AS procpid, \
+ 			pg_stat_get_backend_userid(S.backendid) AS usesysid, \
+ 			U.usename AS usename, \
+ 			pg_stat_get_backend_activity(S.backendid) AS current_query \
+ 		FROM pg_database D, \
+ 			(SELECT pg_stat_get_backend_idset() AS backendid) AS S, \
+ 			pg_shadow U \
+ 		WHERE pg_stat_get_backend_dbid(S.backendid) = D.oid AND \
+ 			pg_stat_get_backend_userid(S.backendid) = U.usesysid;" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
+ echo "CREATE VIEW pg_stat_database AS \
+ 		SELECT \
+ 			D.oid AS datid, \
+ 			D.datname AS datname, \
+ 			pg_stat_get_db_numbackends(D.oid) AS numbackends, \
+ 			pg_stat_get_db_xact_commit(D.oid) AS xact_commit, \
+ 			pg_stat_get_db_xact_rollback(D.oid) AS xact_rollback, \
+ 			pg_stat_get_db_blocks_fetched(D.oid) - \
+ 				pg_stat_get_db_blocks_hit(D.oid) AS blks_read, \
+ 			pg_stat_get_db_blocks_hit(D.oid) AS blks_hit \
+ 		FROM pg_database D;" \
+         | "$PGPATH"/postgres $PGSQL_OPT template1 > /dev/null || exit_nicely
+ 
  echo "Loading pg_description."
  echo "COPY pg_description FROM STDIN" > $TEMPFILE
  cat "$TEMPLATE1_DESCR" >> $TEMPFILE
diff -crN ../src.orig/include/access/heapam.h ./include/access/heapam.h
*** ../src.orig/include/access/heapam.h	Sat Jun  2 11:17:50 2001
--- ./include/access/heapam.h	Sat Jun  2 11:18:33 2001
***************
*** 202,208 ****
  extern void heap_rescan(HeapScanDesc scan, bool scanFromEnd, ScanKey key);
  extern void heap_endscan(HeapScanDesc scan);
  extern HeapTuple heap_getnext(HeapScanDesc scandesc, int backw);
! extern void heap_fetch(Relation relation, Snapshot snapshot, HeapTuple tup, Buffer *userbuf);
  extern ItemPointer heap_get_latest_tid(Relation relation, Snapshot snapshot, ItemPointer tid);
  extern Oid	heap_insert(Relation relation, HeapTuple tup);
  extern int	heap_delete(Relation relation, ItemPointer tid, ItemPointer ctid);
--- 202,208 ----
  extern void heap_rescan(HeapScanDesc scan, bool scanFromEnd, ScanKey key);
  extern void heap_endscan(HeapScanDesc scan);
  extern HeapTuple heap_getnext(HeapScanDesc scandesc, int backw);
! extern void heap_fetch(Relation relation, Snapshot snapshot, HeapTuple tup, Buffer *userbuf, IndexScanDesc iscan);
  extern ItemPointer heap_get_latest_tid(Relation relation, Snapshot snapshot, ItemPointer tid);
  extern Oid	heap_insert(Relation relation, HeapTuple tup);
  extern int	heap_delete(Relation relation, ItemPointer tid, ItemPointer ctid);
diff -crN ../src.orig/include/access/relscan.h ./include/access/relscan.h
*** ../src.orig/include/access/relscan.h	Sat Jun  2 11:17:50 2001
--- ./include/access/relscan.h	Sat Jun  2 11:18:33 2001
***************
*** 36,41 ****
--- 36,43 ----
  	uint16		rs_cdelta;		/* current delta in chain */
  	uint16		rs_nkeys;		/* number of attributes in keys */
  	ScanKey		rs_key;			/* key descriptors */
+ 
+ 	PgStat_Info rs_pgstat_info;	/* statistics collector hook */
  } HeapScanDescData;
  
  typedef HeapScanDescData *HeapScanDesc;
***************
*** 55,60 ****
--- 57,64 ----
  	uint16		numberOfKeys;	/* number of key attributes */
  	ScanKey		keyData;		/* key descriptor */
  	FmgrInfo	fn_getnext;		/* cached lookup info for am's getnext fn */
+ 
+ 	PgStat_Info xs_pgstat_info;	/* statistics collector hook */
  } IndexScanDescData;
  
  typedef IndexScanDescData *IndexScanDesc;
diff -crN ../src.orig/include/catalog/pg_proc.h ./include/catalog/pg_proc.h
*** ../src.orig/include/catalog/pg_proc.h	Sat Jun  2 11:17:50 2001
--- ./include/catalog/pg_proc.h	Sat Jun  2 11:18:33 2001
***************
*** 2614,2619 ****
--- 2614,2656 ----
  DATA(insert OID = 1909 (  int8shr		   PGUID 12 f t t t 2 f 20 "20 23" 100 0 0 100	int8shr - ));
  DESCR("binary shift right");
  
+ DATA(insert OID = 1910 (  pg_stat_get_numscans			PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_numscans - ));
+ DESCR("Statistics: Number of scans done for table/index");
+ DATA(insert OID = 1911 (  pg_stat_get_tuples_returned	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_tuples_returned - ));
+ DESCR("Statistics: Number of tuples read by seqscan");
+ DATA(insert OID = 1912 (  pg_stat_get_tuples_fetched	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_tuples_fetched - ));
+ DESCR("Statistics: Number of tuples fetched by idxscan");
+ DATA(insert OID = 1913 (  pg_stat_get_tuples_inserted	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_tuples_inserted - ));
+ DESCR("Statistics: Number of tuples inserted");
+ DATA(insert OID = 1914 (  pg_stat_get_tuples_updated	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_tuples_updated - ));
+ DESCR("Statistics: Number of tuples updated");
+ DATA(insert OID = 1915 (  pg_stat_get_tuples_deleted	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_tuples_deleted - ));
+ DESCR("Statistics: Number of tuples deleted");
+ DATA(insert OID = 1916 (  pg_stat_get_blocks_fetched	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_blocks_fetched - ));
+ DESCR("Statistics: Number of blocks fetched");
+ DATA(insert OID = 1917 (  pg_stat_get_blocks_hit		PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_blocks_hit - ));
+ DESCR("Statistics: Number of blocks found in cache");
+ DATA(insert OID = 1918 (  pg_stat_get_backend_idset		PGUID 12 f t t t 0 t 23 "" 100 0 0 100	pg_stat_get_backend_idset - ));
+ DESCR("Statistics: Currently active backend IDs");
+ DATA(insert OID = 1919 (  pg_stat_get_backend_pid		PGUID 12 f t t t 1 f 23 "23" 100 0 0 100	pg_stat_get_backend_pid - ));
+ DESCR("Statistics: PID of backend");
+ DATA(insert OID = 1920 (  pg_stat_get_backend_dbid		PGUID 12 f t t t 1 f 26 "23" 100 0 0 100	pg_stat_get_backend_dbid - ));
+ DESCR("Statistics: Database ID of backend");
+ DATA(insert OID = 1921 (  pg_stat_get_backend_userid	PGUID 12 f t t t 1 f 26 "23" 100 0 0 100	pg_stat_get_backend_userid - ));
+ DESCR("Statistics: User ID of backend");
+ DATA(insert OID = 1922 (  pg_stat_get_backend_activity	PGUID 12 f t t t 1 f 25 "23" 100 0 0 100	pg_stat_get_backend_activity - ));
+ DESCR("Statistics: Current query of backend");
+ DATA(insert OID = 1923 (  pg_stat_get_db_numbackends	PGUID 12 f t t t 1 f 23 "26" 100 0 0 100	pg_stat_get_db_numbackends - ));
+ DESCR("Statistics: Number of backends in database");
+ DATA(insert OID = 1924 (  pg_stat_get_db_xact_commit	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_db_xact_commit - ));
+ DESCR("Statistics: Transactions committed");
+ DATA(insert OID = 1925 (  pg_stat_get_db_xact_rollback	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_db_xact_rollback - ));
+ DESCR("Statistics: Transactions rolled back");
+ DATA(insert OID = 1926 (  pg_stat_get_db_blocks_fetched	PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_db_blocks_fetched - ));
+ DESCR("Statistics: Blocks fetched for database");
+ DATA(insert OID = 1927 (  pg_stat_get_db_blocks_hit		PGUID 12 f t t t 1 f 20 "26" 100 0 0 100	pg_stat_get_db_blocks_hit - ));
+ DESCR("Statistics: Block found in cache for database");
+ 
  /*
   * prototypes for functions pg_proc.c
   */
diff -crN ../src.orig/include/pgstat.h ./include/pgstat.h
*** ../src.orig/include/pgstat.h	Wed Dec 31 19:00:00 1969
--- ./include/pgstat.h	Sat Jun  2 11:18:33 2001
***************
*** 0 ****
--- 1,380 ----
+ /* ----------
+  *	pgstat.h
+  *
+  *	Definitions for the PostgreSQL statistics collector daemon.
+  *
+  *	Copyright (c) 2001, PostgreSQL Global Development Group
+  *
+  *  $Id:$
+  * ----------
+  */
+ #ifndef PGSTAT_H
+ #define PGSTAT_H
+ 
+ /* ----------
+  * Paths for the statistics files. The %s is replaced with the
+  * installations $PGDATA.
+  * ----------
+  */
+ #define	PGSTAT_STAT_FILENAME	"%s/pgstat.stat"
+ #define	PGSTAT_STAT_TMPFILE		"%s/pgstat.tmp.%d"
+ 
+ /* ----------
+  * Timer definitions.
+  * ----------
+  */
+ #define PGSTAT_STAT_INTERVAL	500		/* How often to write the status	*/
+ 										/* file in milliseconds.			*/
+ 
+ #define PGSTAT_DESTROY_DELAY	10000	/* How long to keep destroyed		*/
+ 										/* objects known to give delayed	*/
+ 										/* UDP packets time to arrive		*/
+ 										/* in milliseconds.					*/
+ 
+ #define PGSTAT_DESTROY_COUNT	(PGSTAT_DESTROY_DELAY 					\
+ 								/ PGSTAT_STAT_INTERVAL)
+ 
+ 
+ /* ----------
+  * How much of the actual query to send to the collector.
+  * ----------
+  */
+ #define PGSTAT_ACTIVITY_SIZE	256
+ 
+ 
+ /* ----------
+  * The types of backend/postmaster -> collector messages
+  * ----------
+  */
+ #define	PGSTAT_MTYPE_DUMMY			0
+ #define	PGSTAT_MTYPE_BESTART		1
+ #define	PGSTAT_MTYPE_BETERM			2
+ #define	PGSTAT_MTYPE_ACTIVITY		3
+ #define	PGSTAT_MTYPE_TABSTAT		4
+ #define	PGSTAT_MTYPE_TABPURGE		5
+ #define	PGSTAT_MTYPE_DROPDB			6
+ #define	PGSTAT_MTYPE_RESETCOUNTER	7
+ 
+ /* ----------
+  * TODO
+  * For simplicity now, the number of messages buffered in
+  * pgstat_recvbuffer(). Should be an amount of bytes used
+  * for a gapless wraparound buffer.
+  * ----------
+  */
+ #define	PGSTAT_RECVBUFFERSZ		1024
+ 
+ 
+ /* ----------
+  * The initial size hints for the hash tables used in the
+  * collector.
+  * ----------
+  */
+ #define PGSTAT_DB_HASH_SIZE		16
+ #define PGSTAT_BE_HASH_SIZE		512
+ #define PGSTAT_TAB_HASH_SIZE	512
+ 
+ 
+ /* ----------
+  * The data type used for counters.
+  * ----------
+  */
+ typedef int64	PgStat_Counter;
+ 
+ 
+ /* ------------------------------------------------------------
+  * Statistic collector data structures follow
+  * ------------------------------------------------------------
+  */
+ /* ----------
+  * PgStat_StatDBEntry			The collectors data per database
+  * ----------
+  */
+ typedef struct	PgStat_StatDBEntry
+ {
+ 	Oid				databaseid;
+ 	HTAB		   *tables;
+ 	int				n_backends;
+ 	PgStat_Counter	n_connects;
+ 	PgStat_Counter	n_xact_commit;
+ 	PgStat_Counter	n_xact_rollback;
+ 	PgStat_Counter	n_blocks_fetched;
+ 	PgStat_Counter	n_blocks_hit;
+ 	int				destroy;			
+ } PgStat_StatDBEntry;
+ 
+ 
+ /* ----------
+  * PgStat_StatBeEntry			The collectors data per backend
+  * ----------
+  */
+ typedef struct	PgStat_StatBeEntry
+ {
+ 	Oid				databaseid;
+ 	Oid				userid;
+ 	int				procpid;
+ 	char			activity[PGSTAT_ACTIVITY_SIZE];
+ } PgStat_StatBeEntry;
+ 
+ 
+ /* ----------
+  * PgStat_StatBeDead			Because UDP packets can arrive out of
+  *								order, we need to keep some information
+  *								about backends that are known to be
+  *								dead for some seconds. This info is held
+  *								in a hash table of these structs.
+  * ----------
+  */
+ typedef struct	PgStat_StatBeDead
+ {
+ 	int				procpid;
+ 	int				backendid;
+ 	int				destroy;
+ } PgStat_StatBeDead;
+ 
+ 
+ /* ----------
+  * PgStat_StatTabEntry			The collectors data table data
+  * ----------
+  */
+ typedef struct	PgStat_StatTabEntry
+ {
+ 	Oid					tableid;
+ 
+ 	PgStat_Counter		numscans;
+ 
+ 	PgStat_Counter		tuples_returned;
+ 	PgStat_Counter		tuples_fetched;
+ 	PgStat_Counter		tuples_inserted;
+ 	PgStat_Counter		tuples_updated;
+ 	PgStat_Counter		tuples_deleted;
+ 
+ 	PgStat_Counter		blocks_fetched;
+ 	PgStat_Counter		blocks_hit;
+ 
+ 	int					destroy;
+ } PgStat_StatTabEntry;
+ 
+ 
+ /* ------------------------------------------------------------
+  * Message formats follow
+  * ------------------------------------------------------------
+  */
+ 
+ 
+ /* ----------
+  * PgStat_MsgHdr				The common message header
+  * ----------
+  */
+ typedef struct	PgStat_MsgHdr
+ {
+ 	int						m_type;
+ 	int						m_size;
+ 	int						m_backendid;
+ 	int						m_procpid;
+ 	Oid						m_databaseid;
+ 	Oid						m_userid;
+ } PgStat_MsgHdr;
+ 
+ /* ----------
+  * PgStat_TabEntry				A table slot in a MsgTabstat
+  * ----------
+  */
+ typedef struct	PgStat_TableEntry
+ {
+ 	Oid						t_id;
+ 
+ 	PgStat_Counter			t_numscans;
+ 
+ 	PgStat_Counter			t_tuples_returned;
+ 	PgStat_Counter			t_tuples_fetched;
+ 	PgStat_Counter			t_tuples_inserted;
+ 	PgStat_Counter			t_tuples_updated;
+ 	PgStat_Counter			t_tuples_deleted;
+ 
+ 	PgStat_Counter			t_blocks_fetched;
+ 	PgStat_Counter			t_blocks_hit;
+ } PgStat_TableEntry;
+ 
+ 
+ /* ----------
+  * PgStat_MsgDummy				A dummy message, ignored by the collector
+  * ----------
+  */
+ typedef struct	PgStat_MsgDummy
+ {
+ 	PgStat_MsgHdr			m_hdr;
+ 	char					m_dummy[512];
+ } PgStat_MsgDummy;
+ 
+ /* ----------
+  * PgStat_MsgBestart			Sent by the backend on startup
+  * ----------
+  */
+ typedef struct	PgStat_MsgBestart
+ {
+ 	PgStat_MsgHdr			m_hdr;
+ } PgStat_MsgBestart;
+ 
+ /* ----------
+  * PgStat_MsgBeterm				Sent by the postmaster after backend exit
+  * ----------
+  */
+ typedef struct	PgStat_MsgBeterm
+ {
+ 	PgStat_MsgHdr			m_hdr;
+ } PgStat_MsgBeterm;
+ 
+ /* ----------
+  * PgStat_MsgActivity			Sent by the backends when they start
+  *								to parse a query.
+  * ----------
+  */
+ typedef struct	PgStat_MsgActivity
+ {
+ 	PgStat_MsgHdr			m_hdr;
+ 	char					m_what[PGSTAT_ACTIVITY_SIZE];
+ } PgStat_MsgActivity;
+ 
+ /* ----------
+  * How many table entries fit into a MsgTabstat. Actually,
+  * this will keep the UDP packets below 1K, what should fit
+  * unfragmented into the MTU of the lo interface on most
+  * platforms. Does anybody care for platforms where it doesn't?
+  * ----------
+  */
+ #define PGSTAT_NUM_TABENTRIES	((1000 - sizeof(PgStat_MsgHdr))			\
+ 								/ sizeof(PgStat_TableEntry))
+ 
+ /* ----------
+  * PgStat_MsgTabstat			Sent by the backend to report table
+  *								and buffer access statistics.
+  * ----------
+  */
+ typedef struct	PgStat_MsgTabstat
+ {
+ 	PgStat_MsgHdr			m_hdr;
+ 	int						m_nentries;
+ 	int						m_xact_commit;
+ 	int						m_xact_rollback;
+ 	PgStat_TableEntry		m_entry[PGSTAT_NUM_TABENTRIES];
+ } PgStat_MsgTabstat;
+ 
+ 
+ /* ----------
+  * How many Oid entries fit into a MsgTabpurge.
+  * ----------
+  */
+ #define PGSTAT_NUM_TABPURGE		((1000 - sizeof(PgStat_MsgHdr))			\
+ 								/ sizeof(PgStat_TableEntry))
+ 
+ /* ----------
+  * PgStat_MsgTabpurge			Sent by the backend to tell the collector
+  *								about dead tables.
+  * ----------
+  */
+ typedef struct	PgStat_MsgTabpurge
+ {
+ 	PgStat_MsgHdr			m_hdr;
+ 	int						m_nentries;
+ 	Oid						m_tableid[PGSTAT_NUM_TABPURGE];
+ } PgStat_MsgTabpurge;
+ 
+ 
+ /* ----------
+  * PgStat_MsgDropdb				Sent by the backend to tell the collector
+  *								about dropped database
+  * ----------
+  */
+ typedef struct	PgStat_MsgDropdb
+ {
+ 	PgStat_MsgHdr			m_hdr;
+ 	Oid						m_databaseid;
+ } PgStat_MsgDropdb;
+ 
+ 
+ /* ----------
+  * PgStat_MsgResetcounter		Sent by the backend to tell the collector
+  *								to reset counters
+  * ----------
+  */
+ typedef struct	PgStat_MsgResetcounter
+ {
+ 	PgStat_MsgHdr			m_hdr;
+ } PgStat_MsgResetcounter;
+ 
+ 
+ /* ----------
+  * PgStat_Msg					Union over all possible messages.
+  * ----------
+  */
+ typedef union	PgStat_Msg
+ {
+ 	PgStat_MsgHdr			msg_hdr;
+ 	PgStat_MsgDummy			msg_dummy;
+ 	PgStat_MsgBestart		msg_bestart;
+ 	PgStat_MsgActivity		msg_activity;
+ 	PgStat_MsgTabstat		msg_tabstat;
+ 	PgStat_MsgTabpurge		msg_tabpurge;
+ 	PgStat_MsgDropdb		msg_dropdb;
+ 	PgStat_MsgResetcounter	msg_resetcounter;
+ } PgStat_Msg;
+ 
+ 
+ 
+ 
+ /* ----------
+  * Functions called from postmaster
+  * ----------
+  */
+ extern int		pgstat_init(void);
+ extern int		pgstat_start(void);
+ extern int		pgstat_ispgstat(int pid);
+ extern void		pgstat_beterm(int pid);
+ 
+ /* ----------
+  * Functions called from backends
+  * ----------
+  */
+ extern void		pgstat_bestart(void);
+ 
+ extern void		pgstat_ping(void);
+ extern void		pgstat_report_activity(char *what);
+ extern void		pgstat_report_tabstat(void);
+ extern int		pgstat_vacuum_tabstat(void);
+ 
+ extern void		pgstat_reset_counters(void);
+ 
+ extern void		pgstat_initstats(PgStat_Info *stats, Relation rel);
+ 
+ extern void		pgstat_reset_heap_scan(PgStat_Info *stats);
+ extern void		pgstat_count_heap_scan(PgStat_Info *stats);
+ extern void		pgstat_count_heap_getnext(PgStat_Info *stats);
+ extern void		pgstat_count_heap_fetch(PgStat_Info *stats);
+ extern void		pgstat_count_heap_insert(PgStat_Info *stats);
+ extern void		pgstat_count_heap_update(PgStat_Info *stats);
+ extern void		pgstat_count_heap_delete(PgStat_Info *stats);
+ 
+ extern void		pgstat_reset_index_scan(PgStat_Info *stats);
+ extern void		pgstat_count_index_scan(PgStat_Info *stats);
+ extern void		pgstat_count_index_getnext(PgStat_Info *stats);
+ 
+ extern void		pgstat_count_buffer_read(PgStat_Info *stats,
+ 											Relation rel);
+ extern void		pgstat_count_buffer_hit(PgStat_Info *stats,
+ 											Relation rel);
+ extern void		pgstat_count_xact_commit(void);
+ extern void		pgstat_count_xact_rollback(void);
+ 
+ /* ----------
+  * Support functions for the SQL-callable functions to
+  * generate the pgstat* views.
+  * ----------
+  */
+ extern PgStat_StatDBEntry  *pgstat_fetch_stat_dbentry(Oid dbid);
+ extern PgStat_StatTabEntry *pgstat_fetch_stat_tabentry(Oid relid);
+ extern PgStat_StatBeEntry  *pgstat_fetch_stat_beentry(int beid);
+ extern int					pgstat_fetch_stat_numbackends(void);
+ 
+ 
+ #endif /* PGSTAT_H */
diff -crN ../src.orig/include/utils/hsearch.h ./include/utils/hsearch.h
*** ../src.orig/include/utils/hsearch.h	Sat Jun  2 11:17:50 2001
--- ./include/utils/hsearch.h	Sat Jun  2 11:18:33 2001
***************
*** 85,90 ****
--- 85,91 ----
  								 * pointer values */
  	SEG_OFFSET *dir;			/* 'directory' of segm starts */
  	void	   *(*alloc) (Size);/* memory allocator */
+ 	MemoryContext hcxt;			/* memory context if default allocator used */
  } HTAB;
  
  typedef struct hashctl
***************
*** 102,107 ****
--- 103,109 ----
  	long	   *dir;			/* directory if allocated already */
  	long	   *hctl;			/* location of header information in shd
  								 * mem */
+ 	MemoryContext hcxt;			/* memory context to use for all allocations */
  } HASHCTL;
  
  /* Flags to indicate action for hctl */
***************
*** 113,118 ****
--- 115,121 ----
  #define HASH_SHARED_MEM 0x040	/* Setting shared mem const */
  #define HASH_ATTACH		0x080	/* Do not initialize hctl */
  #define HASH_ALLOC		0x100	/* Setting memory allocator */
+ #define HASH_CONTEXT	0x200	/* Setting explicit memory context */
  
  
  /* seg_alloc assumes that INVALID_INDEX is 0 */
diff -crN ../src.orig/include/utils/rel.h ./include/utils/rel.h
*** ../src.orig/include/utils/rel.h	Sat Jun  2 11:17:51 2001
--- ./include/utils/rel.h	Sat Jun  2 11:18:33 2001
***************
*** 85,90 ****
--- 85,103 ----
  	int			numtriggers;
  } TriggerDesc;
  
+ 
+ /* ----------
+  * Same for the statistics collector data in Relation and scan data.
+  * ----------
+  */
+ typedef struct	PgStat_Info
+ {
+ 	void			   *tabentry;
+ 	bool				no_stats;
+ 	bool				heap_scan_counted;
+ 	bool				index_scan_counted;
+ } PgStat_Info;
+ 
  /*
   * Here are the contents of a relation cache entry.
   */
***************
*** 110,115 ****
--- 123,130 ----
  	IndexStrategy rd_istrat;	/* info needed if rel is an index */
  	RegProcedure *rd_support;
  	TriggerDesc *trigdesc;		/* Trigger info, or NULL if rel has none */
+ 
+ 	PgStat_Info	pgstat_info;
  } RelationData;
  
  typedef RelationData *Relation;
